Name:		ghost-docker
Version:	0.5.8
Release:	1%{?dist}
Summary:	Ghost blogging platform in Docker container

Group:		docker-rpm
License:	GPLv3+ and MIT
URL:		https://ghost.org/
Source0:	https://ghost.org/zip/ghost-%{version}.zip
Source1:	context.tar

BuildRequires:	docker-io%{?_isa}
Requires:	docker-io%{?_isa}

%define image 	%{name}-rpm
%define state	%{_sharedstatedir}/%{image}
%define dbdir	%{state}/db

%description
Containerized Ghost blogging platform

%prep
%setup -n %{name}/ghost -c
rm -f config.example.js

%setup -c -T -b 1
cp config.js %{_builddir}/%{name}/ghost/
mkdir -p build-context/ghost
cp -r %{_builddir}/%{name}/ghost/. build-context/ghost

%build
cd build-context/
docker build -t %{image} .

%install
docker save --output='container.tar' %{image}
mkdir -p %{buildroot}/%{state}/
mkdir -p %{buildroot}/%{_sbindir}/
mkdir -p %{buildroot}/%{_prefix}/lib/systemd/system/
mkdir -p %{buildroot}/%{_docdir}/%{name}
mkdir -p %{buildroot}/%{_docdir}/%{name}/ghost
install -m 0644 ghost-docker.service %{buildroot}/%{_prefix}/lib/systemd/system/ghost-docker.service
install -m 0644 container.tar %{buildroot}/%{state}/container.tar
install -m 0744 ghost-docker %{buildroot}/%{_sbindir}/ghost-docker
install -m 0644 env.list %{buildroot}/%{state}/env.list
install -m 0644 -t %{buildroot}/%{_docdir}/%{name} LICENSE README
install -m 0644 -t %{buildroot}/%{_docdir}/%{name}/ghost/ build-context/ghost/README.md build-context/ghost/LICENSE

%clean
rm -rf $RPM_BUILD_ROOT

%pre
mkdir -p %{dbdir}
chcon -t svirt_sandbox_file_t %{dbdir}
echo "  Loading image into Docker"

%post
docker load --input='%{state}/container.tar'
echo '  Image %{image} loaded!'
rm -f %{state}/container.tar && touch %{state}/container.tar

%postun
docker kill $(docker ps | grep %{image} | cut -d' ' -f1) >/dev/null 2>&1
docker rmi -f %{image} >/dev/null 2>&1
echo '  Image %{image} removed!'

%files
%{_sbindir}/ghost-docker
%{state}/container.tar
%{state}/env.list
%{_prefix}/lib/systemd/system/ghost-docker.service

%doc
%{_docdir}/%{name}/*

%changelog
* Mon Jan 19 2015 Pavel Odvody <podvody@redhat.com> - 0.5.8-1
- Initial packaging effort
